#include <cstdio>
#include <cassert>

char survey(int x, int y){
	char res;
	printf("S %d %d\n", x, y);
	fflush(stdout);
	scanf(" %c", &res);
	return res;
}

void neutralize(int x, int y){
	printf("N %d %d\n", x, y);
}

const int di[8]={0, 1, 1, 1, 0, -1, -1, -1};
const int dj[8]={1, 1, 0, -1, -1, -1, 0, 1};

int main(){
	int N, M, K;
	char has;
	int found=0;
	scanf("%d %d %d", &N, &M, &K);
	assert(M<=K);
	int N1=N-N%3;
	int extra=K-M;
	// break the grid into 3x3 chunks, and survey the
	// center of each chunk
	//
	for(int i=0; i<N1; i+=3)
	for(int j=0; j<N1; j+=3){
		// if we have spare dynamite, use it
		if(extra){
			neutralize(i+1, j+1);
			extra--;
		}
		// survey the center cell
		char count = survey(i+1, j+1);
		// neutralize and resurvey
		if(count=='M'){
			neutralize(i+1, j+1);
			count=survey(i+1, j+1);
		}
		// clear surrounding mines
		for(int d=0; count>'0' && d<8; d++){
			int ii=i+di[d]+1, jj=j+dj[d]+1;
			if(survey(ii, jj)=='M' || count+d == 8){
				neutralize(ii, jj);
				count--;
			}
		}
	}
	// survey remaining cells individually
	//
	for(int i=0; i<N; i++)
	for(int j=0; j<N; j++){
		if(i>=N1 || j>=N1){
			if(extra){
				neutralize(i,j);
				extra--;
			}else if(survey(i, j)=='M'){
				neutralize(i, j);
			}
		}
	}
	puts("Done");
	return 0;
}
